<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/24/2004 *
 * ===============                              Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : rewrite_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for rewrite extension          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer rewrite-Erweiterung      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Rewrite links in HTML for better SEO (ugly part of mx!)
function rewriteLinksInCode ($HTML) {
	// Skip rewriting for configured modules
	if (eregi(getModule(), getConfig('rewrite_skip')) !== false) return $HTML;

	// Generate target URL
	$target = '{?URL?}/cms/';

	// Convert modules.php?module=...
	$output = str_replace(getConfig('URL') . '/modules.php?module=', $target, $HTML);

	// Convert modules.php?module=...
	$output = str_replace('{?URL?}/modules.php?module=', $target, $output);

	// Do we have an URL linked to mxchange.org?
	if (eregi(getConfig('SERVER_URL'), $output)) {
		// Convert URLs from my server
		$output = str_replace('{?URL?}/modules.php?module=', getConfig('SERVER_URL') . '/cms/', $output);

		// Convert URLs from my server
		$output = str_replace(getConfig('URL') . '/modules.php?module=', getConfig('SERVER_URL') . '/cms/', $output);
	} // END - if

	// Strip slashes as above for the main URL
	$target2 = preg_quote($target, '/');

	// Action variable
	$action = $target . '$1/act/';

	// Convert &amp;|&action=...
	$output = preg_replace('/' . $target2 . '(.*)&amp;action=/i', $action, $output);

	// "The same procedure as last variable"... now for &amp;what=
	$what = $target.'$1/wht/';
	$output = preg_replace('/' . $target2 . '(.*)&amp;what=/i', $what, $output);

	// Repair missed &amp;what=??? entries
	while (preg_match("/&amp;what=(.*)\/(.*)\/(.*)/i", $output)) {
		$output = preg_replace("/&amp;what=(.*)\/(.*)\/(.*)/i", "/wht/\$1/\$2/\$3", $output);
	} // END - while

	// Return rewritten code
	return $output;
}

// [EOF]
?>
