<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ================                             Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-primera.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Wernis requests                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungsanfragen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	// User is not logged in
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('primera')) && (!isAdmin())) {
	// Extension 'primera' is not activated
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('primera'));
	return;
} // END - if

// Check if the admin has entered the data
if ((getConfig('primera_api_name') == '') || (getConfig('primera_api_md5') == '')) {
	// Something important is missing...
	loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_API_DATA_MISSING'));
	return;
} // END - if

// Init the content array and points
$content = array();
$points = false;

// Is the mode set (payout only)
if (!isGetRequestElementSet('mode')) {
	// Get referal id
	$content['refid'] = getConfig(('primera_refid'));

	// Get Primus id
	$result = SQL_QUERY_ESC("SELECT `primera_userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
		array(getUserId()), __FILE__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch ID
		list($content['primera_nickname']) = SQL_FETCHROW($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Is there an ID?
	if ((!empty($content['primera_nickname'])) && (!isGetRequestElementSet('mode'))) {
		// Then use an other "mode"
		setRequestGetElement('mode', 'list');

		// And load all rows!
		$result = SQL_QUERY_ESC("SELECT `id`,`primera_account`,`primera_amount`,`primera_timestamp`,`primera_type` FROM `{?_MYSQL_PREFIX?}_user_primera` WHERE `userid`=%s ORDER BY `primera_timestamp` DESC",
			array(getUserId()), __FILE__, __LINE__);

		// Load all rows
		$content['rows'] = ''; $SW = 2;
		while ($data = SQL_FETCHARRAY($result)) {
			// Prepare data for output
			$rowContent = array(
				'stamp'		=> generateDateTime($data['primera_timestamp'], 2),
				'points'		=> translateComma($data['primera_amount']),
				'acc'		=> SQL_ESCAPE($data['primera_account']),
				'status'		=> PRIMERA_TRANSFER_STATUS($data['primera_type']),
				'raw_type'	=> strtolower($data['primera_type']),
				'sw'			=> $SW,
			);

			// Load row template
			$content['rows'] .= loadTemplate('member_primera_mode_list_row', true, $rowContent);
			$SW = 3 - $SW;
		}

		// Free result
		SQL_FREERESULT($result);
	} else {
		// Mode pay
		setRequestGetElement('mode', 'pay');
	}
} // END - if

if (getRequestElement('mode') == 'pay') {
	// Get total points and check if the user can request a payout
	$points = countSumTotalData(getUserId(), 'user_points', 'points') - countSumTotalData(getUserId(), 'user_data', 'used_points');

	// No dots here...
	$points = explode('.', $points);
	$points = bigintval($points[0]);

	// Remove the registration fee
	$points = $points - getConfig('points_register');

	// Is this enougth for a payout?
	if ($points < getConfig('primera_min_payout')) {
		// No, then abort here
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MIN_PAYOUT_PAYOUT'), translateComma(getConfig('primera_min_payout'))));
		return;
	}

	// Add points to content array
	$content['points']     = $points;
	$content['min_points'] = translateComma(getConfig('primera_min_payout'));

	// Get Primera id
	$content['primera_nickname'] = '';
	$result = SQL_QUERY_ESC("SELECT `primera_userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
		array(getUserId()), __FILE__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch ID
		list($content['primera_nickname']) = SQL_FETCHROW($result);
	}

	// Free result
	SQL_FREERESULT($result);
} else {
	// Invalid mode!
	loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MODE_INVALID'), getRequestElement('mode')));
	return;
}

// Is the formular sent?
if ((isFormSent()) && (isGetRequestElementSet('mode'))) {
	// Check input data depending on the mode and execute the requested mode
	switch (getRequestElement('mode')) {
		case 'pay': // Payout this exchange -> Primus
			// Is the user ID and password set?
			if (!isPostRequestElementSet(('primera_nickname'))) {
				// Nothing entered in Primus nickname
				loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_USERNAME'));
			} elseif (!isPostRequestElementSet(('primera_password'))) {
				// Nothing entered in Primera password
				loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_PASSWORD'));
			} elseif (!isPostRequestElementSet(('amount'))) {
				// Nothing entered in amount
				loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_AMOUNT'));
			} elseif (postRequestElement('amount') != bigintval(postRequestElement('amount'))) {
				// Only numbers in amount!
				loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_INVALID_AMOUNT'));
			} elseif (postRequestElement('amount') < getConfig('primera_min_payout')) {
				// Not enougth entered!
				loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_AMOUNT_SMALLER_MIN'), getConfig(('primera_min_payout'))));
			} elseif (postRequestElement('amount') > $points) {
				// Not enougth points left!
				loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_PAYOUT_POINTS_DEPLETED'), bigintval(postRequestElement('amount')), bigintval($points)));
			} else {
				// All is fine here so do the payout
				$success = executePrimeraPayout(postRequestElement('primera_nickname'), md5(postRequestElement('primera_password')), postRequestElement('amount'));
				if ($success) {
					// Default is locked!
					$locked = true;

					// Shall I 'pay' the referal points imidiately?
					if (getConfig('ref_payout') == 0) {
						// Yes, 'pay' it now
						$locked = false;
					} // END - if

					// Remove points from account
					subtractPoints('primera_payout', getUserId(), postRequestElement('amount'));

					// Update primera nickname
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `primera_userid`=%s WHERE `userid`=%s LIMIT 1",
						array(postRequestElement('primera_nickname'), getUserId()), __FILE__, __LINE__);

					// All done!
					loadTemplate('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_PAYOUT_DONE'));
					return;
				} elseif ((GET_PRIMERA_ERROR_CODE() == 'user_failed') || (GET_PRIMERA_ERROR_CODE() == 'own_failed') || (GET_PRIMERA_ERROR_CODE() == 'amount_failed') || (GET_PRIMERA_ERROR_CODE() == 'api_amount_failed')) {
					// Wrong login data
					loadTemplate('admin_settings_saved', false, GET_PRIMERA_ERROR_MESSAGE());
				} else {
					// Something went wrong
					loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_PAYOUT_FAILED'), GET_PRIMERA_ERROR_MESSAGE()));
				}
			}
			break;

		default: // Invalid mode!
			logDebugMessage(__FILE__, __LINE__, sprintf("Invalid mode %s detected.", getRequestElement('mode')));
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MODE_INVALID'), getRequestElement('mode')));
			return;
	}
} // END - if

// Prepare mode for template name
$mode = sprintf("member_primera_mode_%s", getRequestElement('mode'));

// Load the template
loadTemplate($mode, false, $content);

//
?>
